## kdevelop 25.04.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

# KDE Gear version, managed by release service script
set(RELEASE_SERVICE_VERSION_MAJOR "25")
set(RELEASE_SERVICE_VERSION_MINOR "04")
set(RELEASE_SERVICE_VERSION_MICRO "0")

set(RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")

# generate patch level from release service version
set(_micro ${RELEASE_SERVICE_VERSION_MICRO})
if (_micro LESS "10")
    string(PREPEND _micro "0") # pad with 0
endif()
set(RELEASE_SERVICE_BASED_PATCHLEVEL "${RELEASE_SERVICE_VERSION_MAJOR}${RELEASE_SERVICE_VERSION_MINOR}${_micro}")

# The math expression below automatically increments KDevelop minor version in each KDE Gear release.
# The multiplier 3 is the number of releases that share ${RELEASE_SERVICE_VERSION_MAJOR}.
# The fraction assigns consecutive minor versions to the 3 releases - 04, 08 and 12. The rounding up groups
# pre-release versions with the corresponding final release versions: 03 with 04, 07 with 08 and 11 with 12.
# The final subtrahend at the end of the expression ensures version continuity: KDevelop 6.0 in KDE Gear 24.08.
math(EXPR KDEVELOP_OWN_MINOR_VERSION "${RELEASE_SERVICE_VERSION_MAJOR} * 3                  \
                                      + (${RELEASE_SERVICE_VERSION_MINOR} + 4 - 3) / 4      \
                                      - 74")

# On macOS KDevelop_VERSION_MINOR is modified below. But KDEV_ITEMREPOSITORY_VERSION should depend on the
# original minor version on all platforms. So the variable ${KDEVELOP_OWN_MINOR_VERSION} is used again later.
project(KDevelop VERSION "6.${KDEVELOP_OWN_MINOR_VERSION}.${RELEASE_SERVICE_BASED_PATCHLEVEL}")

# KDevelop SOVERSION
# E.g. for KDevelop 5.2.0 => SOVERSION 52 (we only promise ABI compatibility between patch version updates)
set(KDEVELOP_SOVERSION "${KDevelop_VERSION_MAJOR}${KDevelop_VERSION_MINOR}")

if (APPLE)
    ###################################################################################
    # Kludge for bug #448152: ld: malformed 64-bit a.b.c.d.e version number: 5.7.211201
    # Apple's linker uses the project version (not the SOVERSION) to calculate an
    # unsigned int in such a way that places restrictions on the magnitude of each tier
    # of the version string.
    # See here: https://www.sicpers.info/2013/03/how-to-version-a-mach-o-library/
    ###################################################################################
    project(KDevelop VERSION "${KDevelop_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${_micro}")
endif()

# plugin version as used e.g. in plugin installation path
set(KDEV_PLUGIN_VERSION "${KDEVELOP_SOVERSION}")

set(QT_MIN_VERSION "6.5.0")
set(KF_MIN_VERSION "6.0.0")

option(BUILD_DOC "Whether to build the documentation" ON)

# we need some parts of the ECM CMake helpers
find_package (ECM ${KF_MIN_VERSION} REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${KDevelop_SOURCE_DIR}/cmake/modules ${ECM_MODULE_PATH})

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE) # needs to be first, as set policies influence following macros
include(ECMOptionalAddSubdirectory)
include(ECMInstallIcons)
include(ECMAddAppIcon)
include(ECMSetupVersion)
include(ECMAddTests)
include(ECMMarkNonGuiExecutable)
include(ECMGenerateHeaders)
include(ECMQtDeclareLoggingCategory)
include(ECMDeprecationSettings)
include(GenerateExportHeader)
include(CMakePackageConfigHelpers)
include(FeatureSummary)
include(WriteBasicConfigVersionFile)
include(CheckFunctionExists)
include(KDevelopMacrosInternal)

find_package(Qt6 ${QT_MIN_VERSION} REQUIRED COMPONENTS
    Concurrent
    Core5Compat
    DBus
    Quick
    QuickWidgets
    Widgets
)
if(BUILD_TESTING)
  find_package(Qt6Test ${QT_MIN_VERSION} REQUIRED)
endif()

find_package(KF6 ${KF_MIN_VERSION} REQUIRED COMPONENTS
  Config
  IconThemes
  I18n
  ItemModels
  ItemViews
  JobWidgets
  KCMUtils
  KIO
  NewStuff
  NotifyConfig
  Parts
  Service
  TextEditor
  ThreadWeaver
  XmlGui
  WindowSystem
  Crash
  GuiAddons
  Archive
  Notifications
  Sonnet
  TextTemplate
  TextWidgets
)
if(BUILD_DOC)
    find_package(KF6DocTools ${KF_MIN_VERSION} REQUIRED)
    set_package_properties(KF6DocTools PROPERTIES
        DESCRIPTION "Tools to generate documentation"
        TYPE REQUIRED
    )
endif()

set(HAVE_KSYSGUARD FALSE)
find_package(KSysGuard CONFIG QUIET)
set_package_properties(KSysGuard PROPERTIES
    PURPOSE "Framework for process listing. Required for the 'Attach to Process' feature"
    TYPE RECOMMENDED
)
if(KSysGuard_FOUND)
    set(HAVE_KSYSGUARD TRUE)
endif()

find_package(KDevelopPGQt 2.4 QUIET) # TODO (once we require KDevelopPGQt version 2.4 or later): remove QUIET again
set_package_properties(KDevelopPGQt PROPERTIES
    PURPOSE "KDevelop parser generator library. Required for the QMake Builder/Manager plugin."
    TYPE RECOMMENDED
)
if (NOT KDevelopPGQt_FOUND)
    find_package(KDevelop-PG-Qt 2.3)
    set_package_properties(KDevelop-PG-Qt PROPERTIES
        PURPOSE "KDevelop parser generator library (older name & version). Required for the QMake Builder/Manager plugin."
        TYPE RECOMMENDED
    )
endif()

find_package(SharedMimeInfo 1.9 REQUIRED)

# added by KDE_COMPILERSETTINGS_LEVEL 5.85.0
remove_definitions(
    -DQT_NO_KEYWORDS
)
add_definitions(
    -DQT_NO_SIGNALS_SLOTS_KEYWORDS
)
ecm_set_disabled_deprecation_versions(
    DISABLE_NEWER_WARNINGS # remove again once Qt6/KF6 porting work fully done
    QT ${QT_MIN_VERSION}
    KF ${KF_MIN_VERSION}
)

# Globally enable PIC since static libraries need it for Qt staticMetaObject
# Furthermore, without that we cannot easily compile with ASAN either
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

# Turn off missing-field-initializers warning for GCC to avoid noise from false positives with empty {}
# See discussion: https://mail.kde.org/pipermail/kdevelop-devel/2014-February/046910.html
add_compile_flag_if_supported(-Wno-missing-field-initializers)
add_compile_flag_if_supported(-Werror=switch)
add_compile_flag_if_supported(-Werror=undefined-bool-conversion)
add_compile_flag_if_supported(-Werror=tautological-undefined-compare)
add_compile_flag_if_supported(-Werror=implicit-fallthrough)    # Use [[fallthrough]] for false positives.
if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    add_compile_flag_if_supported(-Wdocumentation)
    add_compile_flag_if_supported(-Wcovered-switch-default)
    add_compile_flag_if_supported(-Wunreachable-code-break)
    # This warning is triggered by every call to qCDebug()
    add_compile_flag_if_supported(-Wno-gnu-zero-variadic-macro-arguments)
endif()
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    add_compile_flag_if_supported(-pedantic)
    add_compile_flag_if_supported(-Wzero-as-null-pointer-constant CXX_ONLY)
endif()
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    add_compile_flag_if_supported(-Wsuggest-override CXX_ONLY)
endif()

string(TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_TOLOWER)
if(CMAKE_BUILD_TYPE_TOLOWER MATCHES "debug"
  OR CMAKE_BUILD_TYPE_TOLOWER STREQUAL "")
  set(COMPILER_OPTIMIZATIONS_ENABLED OFF)
else()
  set(COMPILER_OPTIMIZATIONS_ENABLED ON)
endif()

option(BUILD_BENCHMARKS "Whether benchmarks should be compiled or not" ${COMPILER_OPTIMIZATIONS_ENABLED})

# create config-kdevelop.h
configure_file(config-kdevelop.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-kdevelop.h)
include_directories(${KDevelop_BINARY_DIR}) # for config-kdevelop.h

add_subdirectory(3rdparty/timsort)

add_subdirectory(kdevplatform)
add_subdirectory(plugins)

add_subdirectory(pics)
add_subdirectory(app)
add_subdirectory(app_templates)
add_subdirectory(file_templates)
add_subdirectory(shortcuts)
add_subdirectory(share)

if(BUILD_DOC)
    add_subdirectory(doc)
    kdoctools_install(po)
endif()

set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/KDevelop")
configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/KDevelopConfig.cmake.in"
                                  "${CMAKE_CURRENT_BINARY_DIR}/KDevelopConfig.cmake"
                                  INSTALL_DESTINATION ${CMAKECONFIG_INSTALL_DIR}
)
ecm_setup_version(PROJECT
                  VARIABLE_PREFIX KDEVELOP
                  VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/kdevelop_version.h"
                  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KDevelopConfigVersion.cmake"
)
install(FILES
        "${CMAKE_CURRENT_BINARY_DIR}/kdevelop_version.h"
        DESTINATION "${KDE_INSTALL_INCLUDEDIR}/kdevelop")
install(FILES
        "${CMAKE_CURRENT_BINARY_DIR}/KDevelopConfig.cmake"
        "${CMAKE_CURRENT_BINARY_DIR}/KDevelopConfigVersion.cmake"
        DESTINATION "${CMAKECONFIG_INSTALL_DIR}" )
install(EXPORT KDevelopTargets DESTINATION "${CMAKECONFIG_INSTALL_DIR}" NAMESPACE KDev:: FILE KDevelopTargets.cmake)

# kdebugsettings file
install_qt_logging_categories(TYPE APP_PLUGIN)

install(FILES org.kde.kdevelop.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR})

# Make it possible to use the po files fetched by the fetch-translations step
ki18n_install(po)

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== app_templates/CMakeLists.txt ===
kdevplatform_add_app_templates(
    cpp/CMake/cmake_plaincpp
    cpp/CMake/cmake_qt6widgetsapp
    cpp/CMake/cmake_kdevplugin
    cpp/CMake/cmake_qt6quick_app
    cpp/meson/meson_plaincpp
    cpp/QMake/qmake_qt5guiapp
    cpp/QMake/qt5-qml2
    c/CMake/cmake_plainc
    c/meson/meson_plainc
    empty
    kdevelop/file_template_template
)

=== kdevplatform/sublime/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevplatform\")

add_subdirectory(examples)
if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

set(sublime_LIB_SRCS
    area.cpp
    areaindex.cpp
    container.cpp
    controller.cpp
    document.cpp
    mainwindow.cpp
    mainwindow_p.cpp
    mainwindowoperator.cpp
    urldocument.cpp
    tooldocument.cpp
    view.cpp
    viewbarcontainer.cpp
    sublimedefs.cpp
    aggregatemodel.cpp
    holdupdates.cpp

    idealcontroller.cpp
    ideallayout.cpp
    idealtoolbutton.cpp
    idealdockwidget.cpp
    idealbuttonbarwidget.cpp

    message.cpp
    messagewidget.cpp
)
declare_qt_logging_category(sublime_LIB_SRCS
    TYPE LIBRARY
    CATEGORY_BASENAME "sublime"
)
kdevplatform_add_library(KDevPlatformSublime SOURCES ${sublime_LIB_SRCS})
target_link_libraries(KDevPlatformSublime
PUBLIC
    KF6::Parts
PRIVATE
    KF6::KIOWidgets
    KF6::I18n
    KF6::TextWidgets
)

install(FILES
    area.h
    areaindex.h
    areawalkers.h
    container.h
    controller.h
    document.h
    mainwindow.h
    mainwindowoperator.h
    message.h
    urldocument.h
    sublimedefs.h
    tooldocument.h
    view.h
    viewbarcontainer.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kdevplatform/sublime COMPONENT Devel)

=== kdevplatform/util/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevplatform\")

########### next target ###############

set(KDevPlatformUtil_LIB_SRCS
    autoorientedsplitter.cpp
    filesystemhelpers.cpp
    foregroundlock.cpp
    formattinghelpers.cpp
    zoomcontroller.cpp
    wildcardhelpers.cpp
    kdevstringhandler.cpp
    focusedtreeview.cpp
    processlinemaker.cpp
    commandexecutor.cpp
    environmentselectionwidget.cpp
    environmentselectionmodel.cpp
    environmentprofilelist.cpp
    jobstatus.cpp
    activetooltip.cpp
    kdevcoreaddons/kcompoundjob.cpp
    kdevcoreaddons/ksequentialcompoundjob.cpp
    executecompositejob.cpp
    shellutils.cpp
    multilevellistview.cpp
    objectlist.cpp
    placeholderitemproxymodel.cpp
    projecttestjob.cpp
    widgetcolorizer.cpp
    path.cpp
    texteditorhelpers.cpp
    stack.cpp
    expandablelineedit.cpp
)

if(NOT WIN32)
    add_subdirectory(dbus_socket_transformer)
endif()

if(BUILD_TESTING)
    add_subdirectory(duchainify) # needs KDev::Tests
endif()

if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

declare_qt_logging_category(KDevPlatformUtil_LIB_SRCS
    TYPE LIBRARY
    CATEGORY_BASENAME "util"
)

kdevplatform_add_library(KDevPlatformUtil SOURCES ${KDevPlatformUtil_LIB_SRCS})
target_link_libraries(KDevPlatformUtil
PUBLIC
    KDev::Interfaces
PRIVATE
    Qt::Core5Compat
    KF6::ItemModels
    KF6::GuiAddons
)
install( FILES kdevplatform_shell_environment.sh DESTINATION bin PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ)

add_executable(kdev_format_source kdevformatsource.cpp kdevformatfile.cpp)
ecm_mark_nongui_executable(kdev_format_source)
target_link_libraries(kdev_format_source Qt::Core Qt::Core5Compat)
install(TARGETS kdev_format_source DESTINATION ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

install(FILES .zshrc PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ
        DESTINATION ${KDE_INSTALL_DATAROOTDIR}/kdevplatform/shellutils/)

########### install files ###############

install( FILES
    algorithm.h
    autoorientedsplitter.h
    filesystemhelpers.h
    foregroundlock.h
    formattinghelpers.h
    zoomcontroller.h
    wildcardhelpers.h
    kdevstringhandler.h
    ksharedobject.h
    focusedtreeview.h
    activetooltip.h
    processlinemaker.h
    commandexecutor.h
    environmentselectionwidget.h
    environmentprofilelist.h
    jobstatus.h
    pushvalue.h
    kdevvarlengtharray.h
    embeddedfreetree.h
    executecompositejob.h
    convenientfreelist.h
    multilevellistview.h
    namespacedoperatorbitwiseorworkaroundqtbug.h
    objectlist.h
    owningrawpointercontainer.h
    placeholderitemproxymodel.h
    projecttestjob.h
    widgetcolorizer.h
    path.h
    scopedincrementor.h
    stack.h
    stringviewhelpers.h
    texteditorhelpers.h
    toggleonlybool.h
    ${CMAKE_CURRENT_BINARY_DIR}/utilexport.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kdevplatform/util COMPONENT Devel)

install( FILES
    kdevcoreaddons/kcompoundjob.h
    kdevcoreaddons/ksequentialcompoundjob.h
    kdevcoreaddons/ksimplesequentialcompoundjob.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kdevplatform/util/kdevcoreaddons COMPONENT Devel)

=== app/plasma/applet/CMakeLists.txt ===
plasma_install_package(package org.kde.kdevelopsessions)

set(kdevelopsessionsplugin_SRCS
    plugin/kdevelopsessionsplugin.cpp
    plugin/sessionlistmodel.cpp
)

add_library(kdevelopsessionsplugin SHARED ${kdevelopsessionsplugin_SRCS})

target_link_libraries(kdevelopsessionsplugin
    KDevelopSessionsWatch
    Plasma::Plasma
    KF6::I18n
    Qt::Qml
)

install(TARGETS kdevelopsessionsplugin DESTINATION ${KDE_INSTALL_QMLDIR}/org/kde/plasma/private/kdevelopsessions)
install(FILES plugin/qmldir DESTINATION ${KDE_INSTALL_QMLDIR}/org/kde/plasma/private/kdevelopsessions)

=== kdevplatform/sublime/tests/CMakeLists.txt ===
remove_definitions(
    -DQT_NO_CAST_FROM_ASCII
    -DQT_NO_CAST_TO_ASCII
    -DQT_NO_CAST_FROM_BYTEARRAY
)

set(test_areaoperation_SRCS test_areaoperation.cpp areaprinter.cpp)
ecm_add_test(${test_areaoperation_SRCS}
    TEST_NAME test_areaoperation
    LINK_LIBRARIES Qt::Test KF6::Parts KDev::Sublime)


set(test_areawalker_SRCS test_areawalker.cpp areaprinter.cpp)
ecm_add_test(${test_areawalker_SRCS}
    TEST_NAME test_areawalker
    LINK_LIBRARIES Qt::Test KF6::Parts KDev::Sublime)

ecm_add_test(test_view.cpp
    LINK_LIBRARIES Qt::Test KF6::Parts KDev::Sublime)

ecm_add_test(test_document.cpp
    LINK_LIBRARIES Qt::Test KF6::Parts KDev::Sublime)

ecm_add_test(test_controller.cpp
    LINK_LIBRARIES Qt::Test KF6::Parts KDev::Sublime)

ecm_add_test(test_viewactivation.cpp
    LINK_LIBRARIES Qt::Test KF6::Parts KDev::Sublime)

ecm_add_test(test_aggregatemodel.cpp
    LINK_LIBRARIES Qt::Test KF6::Parts KDev::Sublime)

ecm_add_test(test_toolviewtoolbar.cpp
    LINK_LIBRARIES Qt::Test KF6::Parts KDev::Sublime)

=== plugins/git/tests/CMakeLists.txt ===
# Running the test only makes sense if the git command line client
# is present. So check for it before adding the test...
find_program(GIT_FOUND NAMES git)

if (GIT_FOUND)
    include_directories(
        ..
        ${CMAKE_CURRENT_BINARY_DIR}/..
    )

    remove_definitions(
        -DQT_NO_CAST_FROM_ASCII
        -DQT_NO_CAST_TO_ASCII
        -DQT_NO_CAST_FROM_BYTEARRAY
    )

    set(gittest_SRCS
        test_git.cpp
        ../repostatusmodel.cpp
        ../committoolview.cpp
        ../diffviewsctrl.cpp
        ../simplecommitform.cpp
        ../gitplugin.cpp
        ../gitclonejob.cpp
        ../stashmanagerdialog.cpp
        ../stashpatchsource.cpp
        ../rebasedialog.cpp
        ../gitjob.cpp
        ../gitmessagehighlighter.cpp
        ../gitplugincheckinrepositoryjob.cpp
        ../gitnameemaildialog.cpp
        ${kdevgit_LOG_PART_SRCS}
    )
    ki18n_wrap_ui(gittest_SRCS ../stashmanagerdialog.ui)
    ki18n_wrap_ui(gittest_SRCS ../gitnameemaildialog.ui)
    ki18n_wrap_ui(gittest_SRCS ../rebasedialog.ui)
    ecm_add_test(${gittest_SRCS}
        TEST_NAME test_kdevgit
        LINK_LIBRARIES Qt::Test KF6::SonnetUi Qt::Core5Compat KF6::TextWidgets KDev::Vcs KDev::Util KDev::Tests
        GUI)
endif ()

=== plugins/qmakemanager/parser/CMakeLists.txt ===
if (KDevelop-PG-Qt_FOUND)
    include_directories(
        ${KDEVPGQT_INCLUDE_DIR}
    )
endif()
include_directories(
    ${CMAKE_CURRENT_BINARY_DIR}/..
)
set(kdevqmakeparser_SRCS
    qmakeast.cpp
    qmakedriver.cpp
    qmakedebugvisitor.cpp
    buildastvisitor.cpp
    qmakelexer.cpp
    qmakeastvisitor.cpp
    qmakeastdefaultvisitor.cpp
    )

if (KDevelopPGQt_FOUND)
    kdeveloppgqt_generate(parser_GEN_SRCS
        qmake
        NAMESPACE QMake
        DUMP_INFO
        ENFORCE_COMPATIBLE_ERROR_AWARE_CODE
        "${CMAKE_CURRENT_SOURCE_DIR}/qmake.g"
        "${CMAKE_CURRENT_SOURCE_DIR}/qmakelexer.h"
    )
else()
    if(NOT KDevelop-PG-Qt_VERSION VERSION_LESS "2.2.1")
        set(_kdevpgqt_generate_extra_args ENFORCE_COMPATIBLE_ERROR_AWARE_CODE)
    endif()
    kdevpgqt_generate(parser_GEN_SRCS qmake NAMESPACE QMake DUMP_INFO ${_kdevpgqt_generate_extra_args}
        "${CMAKE_CURRENT_SOURCE_DIR}/qmake.g"
        "${CMAKE_CURRENT_SOURCE_DIR}/qmakelexer.h")
endif()

if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

option(BUILD_qmake_parser "Build the qmake-parser debugging tool" OFF)
if(BUILD_qmake_parser)
  add_executable(qmake-parser ${qmakecommon_LOG_SRCS} main.cpp)
  target_link_libraries(qmake-parser kdevqmakeparser KF6::CoreAddons Qt::Core)
  install(TARGETS qmake-parser ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
endif()

add_library(kdevqmakeparser STATIC ${kdevqmakeparser_SRCS} ${parser_GEN_SRCS})
generate_export_header(kdevqmakeparser BASE_NAME parser EXPORT_MACRO_NAME KDEVQMAKEPARSER_EXPORT)
target_link_libraries(kdevqmakeparser
    PUBLIC
        KDev::Util
    PRIVATE
        KF6::CoreAddons
        KF6::KIOCore
        Qt::Core5Compat
)
target_include_directories(kdevqmakeparser PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
if (KDevelopPGQt_FOUND)
    target_link_libraries(kdevqmakeparser PUBLIC
        KDevelopPGQt::Utils
    )
endif()

# for proper include stack reports with gcc when working on the parser:
# remove ENFORCE_COMPATIBLE_ERROR_AWARE_CODE from kdevpgqt_generate
# uncomment next line:
# add_target_compile_flag_if_supported(kdevqmakeparser PRIVATE "-Wno-pedantic")

=== kdevplatform/language/duchain/tests/CMakeLists.txt ===
remove_definitions(
    -DQT_NO_CAST_FROM_ASCII
)

ecm_add_test(test_duchain.cpp
    LINK_LIBRARIES KF6::TextEditor Qt::Test KDev::Tests KDev::Language)

ecm_add_test(test_duchainshutdown.cpp
    LINK_LIBRARIES Qt::Test KDev::Tests KDev::Language)

ecm_add_test(test_identifier.cpp
    LINK_LIBRARIES Qt::Test KDev::Tests KDev::Language)
add_target_compile_flag_if_supported(test_identifier PRIVATE -Wno-self-assign-overloaded) # self-assignments are on purpose here

ecm_add_test(test_stringhelpers.cpp
    LINK_LIBRARIES Qt::Test KDev::Tests KDev::Language)

if(BUILD_BENCHMARKS)
    ecm_add_test(bench_hashes.cpp
        LINK_LIBRARIES Qt::Test KDev::Tests KDev::Language)
    set_tests_properties(bench_hashes PROPERTIES TIMEOUT 30)
endif()

=== plugins/cmake/tests/manual/conditions_in_subdirectory_based_on_root_variables/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

set(ROOT_VARIABLE TRUE)

find_package(Qt6Core REQUIRED)
add_subdirectory(subdirectory)

add_executable(root-foo foo.cpp)

if(ROOT_VARIABLE)
    add_executable(root-foo-variable foo.cpp)
endif()

if(Qt6Core_FOUND)
    add_executable(root-foo-package-found foo.cpp)
endif()

=== plugins/cmake/tests/manual/kf6_app/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

find_package(ECM 1.0.0 REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${KDevelop_SOURCE_DIR}/cmake/modules ${ECM_MODULE_PATH})

include(KDEInstallDirs)
include(KDEFrameworkCompilerSettings NO_POLICY_SCOPE)
include(KDECMakeSettings)

find_package(KF6 REQUIRED WidgetsAddons)

add_executable(myprogram main.cpp)
target_link_libraries(myprogram KF6::WidgetsAddons)

=== plugins/cmake/tests/manual/relative_paths/out/CMakeLists.txt ===
project (test) 
add_executable(test "../src/code.cpp")
include_directories("../inc")

=== debian/changelog ===
kdevelop (4:25.04.0-1) experimental; urgency=medium

  [ Aurélien COUDERC ]
  * New upstream release (25.04.0).
  * Update build-deps and deps with the info from cmake.
  * Adapt packaging to libraries soname bump from 61 to 62.

 -- Aurélien COUDERC <coucouf@debian.org>  Sun, 04 May 2025 14:40:46 +0200

=== debian/control ===
Source: kdevelop
Section: devel
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
           Pino Toscano <pino@debian.org>,
Build-Depends: debhelper-compat (= 13),
               dh-sequence-kf6,
               dh-sequence-qmldeps,
               bash-completion,
               clang (>= 1:6.0),
               cmake (>= 3.16~),
               extra-cmake-modules (>= 6.0.0~),
               kdevelop-pg-qt (>= 2.3~),
               libastyle-dev (>= 3.1),
               libboost-dev (>= 1.35.0~),
               libclang-dev,
               libkf6archive-dev (>= 6.0.0~),
               libkf6config-dev (>= 6.0.0~),
               libkf6crash-dev (>= 6.0.0~),
               libkf6doctools-dev (>= 6.0.0~),
               libkf6guiaddons-dev (>= 6.0.0~),
               libkf6i18n-dev (>= 6.0.0~),
               libkf6iconthemes-dev (>= 6.0.0~),
               libkf6itemmodels-dev (>= 6.0.0~),
               libkf6itemviews-dev (>= 6.0.0~),
               libkf6jobwidgets-dev (>= 6.0.0~),
               libkf6kcmutils-dev (>= 6.0.0~),
               libkf6kio-dev (>= 6.0.0~),
               libkf6newstuff-dev (>= 6.0.0~),
               libkf6notifications-dev (>= 6.0.0~),
               libkf6notifyconfig-dev (>= 6.0.0~),
               libkf6parts-dev (>= 6.0.0~),
               libkf6purpose-dev,
               libkf6runner-dev,
               libkf6service-dev (>= 6.0.0~),
               libkf6sonnet-dev (>= 6.0.0~),
               libkf6texteditor-dev (>= 6.0.0~),
               libkf6texttemplate-dev (>= 6.0.0~),
               libkf6textwidgets-dev (>= 6.0.0~),
               libkf6threadweaver-dev (>= 6.0.0~),
               libkf6windowsystem-dev (>= 6.0.0~),
               libkf6xmlgui-dev (>= 6.0.0~),
               libkomparediff2-dev (>= 6.0~),
               libksysguard-dev,
               libplasma-dev,
               libsvn-dev,
               llvm-dev,
               pkgconf,
               qt6-5compat-dev (>= 6.5.0~),
               qt6-base-dev (>= 6.5.0~),
               qt6-declarative-dev (>= 6.5.0~),
               qt6-tools-dev,
               qt6-webengine-dev,
               shared-mime-info (>= 1.9~),
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://www.kdevelop.org/
Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/kdevelop
Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/kdevelop.git

Package: kdevelop62-libs
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: shared libraries for the KDevelop platform
 This package contains shared libraries needed to run integrated development
 environments based on the KDevelop platform.
 .
 This package is part of the KDevelop platform.

Package: kdevelop
Architecture: any
Depends: kdevelop-data (>= ${source:Version}),
         kdevelop62-libs (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: g++,
            gcc,
            gdb (>= 7.0),
            kapptemplate,
            kio-extras,
            make,
            ${kdevelop:clang},
Suggests: clang,
          clang-tidy,
          clazy,
          cmake (>= 3.16~),
          cppcheck,
          git,
          heaptrack [linux-any],
          kdevelop-l10n,
          konsole,
          meson,
          ninja-build,
Description: integrated development environment for C/C++ and other languages
 KDevelop is a Free and Open Source integrated development
 environment (IDE). It provides editing, navigation and debugging features for
 several programming languages, as well as integration with multiple build
 systems and version-control systems, using a plugin-based architecture.
 .
 KDevelop has parser backends for C, C++ and Javascript/QML, with further
 external plugins supporting e.g. PHP or Python.

Package: kdevelop-data
Architecture: all
Depends: ${misc:Depends},
Description: data files for the KDevelop IDE
 KDevelop is a Free and Open Source integrated development
 environment (IDE). It provides editing, navigation and debugging features for
 several programming languages, as well as integration with multiple build
 systems and version-control systems, using a plugin-based architecture.
 .
 This package contains arch independent data for KDevelop.

Package: kdevelop-dev
Section: libdevel
Architecture: any
Depends: kdevelop62-libs (= ${binary:Version}),
         libboost-dev (>= 1.35.0~),
         libkf6config-dev (>= 6.0.0~),
         libkf6guiaddons-dev (>= 6.0.0~),
         libkf6i18n-dev (>= 6.0.0~),
         libkf6iconthemes-dev (>= 6.0.0~),
         libkf6kio-dev (>= 6.0.0~),
         libkf6parts-dev (>= 6.0.0~),
         libkf6texteditor-dev (>= 6.0.0~),
         libkf6threadweaver-dev (>= 6.0.0~),
         qt6-5compat-dev (>= 6.5.0~),
         qt6-base-dev (>= 6.5.0~),
         qt6-declarative-dev (>= 6.5.0~),
         qt6-webengine-dev,
         ${misc:Depends},
Description: development files for the KDevelop IDE
 KDevelop is a Free and Open Source integrated development
 environment (IDE). It provides editing, navigation and debugging features for
 several programming languages, as well as integration with multiple build
 systems and version-control systems, using a plugin-based architecture.
 .
 This package contains development files for KDevelop.

Package: kdevelop-l10n
Section: localization
Architecture: all
Depends: ${misc:Depends},
Description: localization files for the KDevelop IDE
 KDevelop is a Free and Open Source integrated development
 environment (IDE). It provides editing, navigation and debugging features for
 several programming languages, as well as integration with multiple build
 systems and version-control systems, using a plugin-based architecture.
 .
 This package contains the translations for KDevelop.

Package: plasma-kdevelop
Architecture: linux-any
Depends: kdevelop (= ${binary:Version}),
         ${misc:Depends},
         ${qml6:Depends},
         ${shlibs:Depends},
Description: KDevelop plugins for Plasma
 KDevelop is a Free and Open Source integrated development
 environment (IDE). It provides editing, navigation and debugging features for
 several programming languages, as well as integration with multiple build
 systems and version-control systems, using a plugin-based architecture.
 .
 This package contains the KDevelop plugins for integrating in the Plasma
 desktop environment:
  * sessions data engine
  * sessions widget
  * sessions KRunner module

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# from the top-level CMakeLists.txt
export KDEV_PLUGIN_VERSION=62

# The clang-N used for the build by the unversioned clang
current_clang_pkg = $(shell dpkg -S "$(shell realpath $(shell env PATH=$$(echo "$$PATH" | sed -r -e 's|/usr/lib/ccache/?:||') which clang))" | cut -d: -f1)
# The upstream version of a package passed as parameter
upstream_version_of_pkg = $(shell dpkg-query -f '$${Version}' -W $(1) | sed -e 's/-[^-]*$$//')
# The clang dependency string
clang_dependency = $(current_clang_pkg) (>= $(call upstream_version_of_pkg,$(current_clang_pkg))~)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -Skf6 -- -DBUILD_TESTING=OFF

override_dh_gencontrol:
	dh_gencontrol -- -V'kdevelop:clang=$(clang_dependency)'

.PHONY: override_dh_auto_test

## kdevelop 25.04.3

=== debian/changelog ===
kdevelop (4:25.04.3-0ubuntu1) questing; urgency=medium

  * New upstream release (25.04.3)

 -- Rik Mills <rikmills@kde.org>  Thu, 03 Jul 2025 07:42:24 +0100

kdevelop (4:25.04.2-0ubuntu1) questing; urgency=medium

  * New upstream release (25.04.2)

 -- Rik Mills <rikmills@kde.org>  Thu, 05 Jun 2025 11:44:30 +0100

kdevelop (4:25.04.1-0ubuntu1) questing; urgency=medium

  * New upstream release (25.04.1)

 -- Rik Mills <rikmills@kde.org>  Wed, 07 May 2025 22:05:51 +0100

kdevelop (4:25.04.0-0ubuntu1) questing; urgency=medium

  * New upstream release (25.04.0)
    * Rename packages according to the SONAME bumps:
    - kdevelop61-libs -> kdevelop62-libs
  * Bump KDEV_PLUGIN_VERSION to 62, according to upstream.
  * Update install files.

 -- Rik Mills <rikmills@kde.org>  Wed, 30 Apr 2025 19:48:35 +0100

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,16 @@
 Source: kdevelop
 Section: devel
 Priority: optional
-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
+Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
 Uploaders: Aurélien COUDERC <coucouf@debian.org>,
            Pino Toscano <pino@debian.org>,
-Build-Depends: debhelper-compat (= 13),
+Build-Depends: bash-completion,
+               clang (>= 1:6.0),
+               cmake (>= 3.16~),
+               debhelper-compat (= 13),
                dh-sequence-kf6,
                dh-sequence-qmldeps,
-               bash-completion,
-               clang (>= 1:6.0),
-               cmake (>= 3.16~),
                extra-cmake-modules (>= 6.0.0~),
                kdevelop-pg-qt (>= 2.3~),
                libastyle-dev (>= 3.1),
@@ -41,7 +42,7 @@
                libkf6threadweaver-dev (>= 6.0.0~),
                libkf6windowsystem-dev (>= 6.0.0~),
                libkf6xmlgui-dev (>= 6.0.0~),
-               libkomparediff2-dev (>= 6.0~),
+               libkomparediff2-dev (>= 4:25.04.3~),
                libksysguard-dev,
                libplasma-dev,
                libsvn-dev,
@@ -56,12 +57,12 @@
 Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://www.kdevelop.org/
-Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/kdevelop
-Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/kdevelop.git
+Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kdevelop
+Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kdevelop
 
 Package: kdevelop62-libs
 Section: libs
-Architecture: any
+Architecture: amd64 arm64 armhf
 Depends: ${misc:Depends}, ${shlibs:Depends},
 Description: shared libraries for the KDevelop platform
  This package contains shared libraries needed to run integrated development
@@ -70,7 +71,7 @@
  This package is part of the KDevelop platform.
 
 Package: kdevelop
-Architecture: any
+Architecture: amd64 arm64 armhf
 Depends: kdevelop-data (>= ${source:Version}),
          kdevelop62-libs (= ${binary:Version}),
          ${misc:Depends},
@@ -115,7 +116,7 @@
 
 Package: kdevelop-dev
 Section: libdevel
-Architecture: any
+Architecture: amd64 arm64 armhf
 Depends: kdevelop62-libs (= ${binary:Version}),
          libboost-dev (>= 1.35.0~),
          libkf6config-dev (>= 6.0.0~),
@@ -152,7 +153,7 @@
  This package contains the translations for KDevelop.
 
 Package: plasma-kdevelop
-Architecture: linux-any
+Architecture: amd64 arm64 armhf
 Depends: kdevelop (= ${binary:Version}),
          ${misc:Depends},
          ${qml6:Depends},

## kdevelop 25.07.80

=== debian/changelog ===
kdevelop (4:25.07.80-0ubuntu1) questing; urgency=medium

  * New upstream (beta) release (25.07.80)
  * Rename packages according to the SONAME bumps:
    - kdevelop62-libs -> kdevelop63-libs
  * Bump KDEV_PLUGIN_VERSION to 63, according to upstream.
  * Update install files.


 -- Rik Mills <rikmills@kde.org>  Sun, 13 Jul 2025 11:59:47 +0100

=== debian/control ===
--- 
+++ 
@@ -42,7 +42,7 @@
                libkf6threadweaver-dev (>= 6.0.0~),
                libkf6windowsystem-dev (>= 6.0.0~),
                libkf6xmlgui-dev (>= 6.0.0~),
-               libkomparediff2-dev (>= 4:25.04.3~),
+               libkomparediff2-dev (>= 4:25.07.80~),
                libksysguard-dev,
                libplasma-dev,
                libsvn-dev,
@@ -60,7 +60,7 @@
 Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kdevelop
 Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kdevelop
 
-Package: kdevelop62-libs
+Package: kdevelop63-libs
 Section: libs
 Architecture: amd64 arm64 armhf
 Depends: ${misc:Depends}, ${shlibs:Depends},
@@ -73,7 +73,7 @@
 Package: kdevelop
 Architecture: amd64 arm64 armhf
 Depends: kdevelop-data (>= ${source:Version}),
-         kdevelop62-libs (= ${binary:Version}),
+         kdevelop63-libs (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends},
 Recommends: g++,
@@ -117,7 +117,7 @@
 Package: kdevelop-dev
 Section: libdevel
 Architecture: amd64 arm64 armhf
-Depends: kdevelop62-libs (= ${binary:Version}),
+Depends: kdevelop63-libs (= ${binary:Version}),
          libboost-dev (>= 1.35.0~),
          libkf6config-dev (>= 6.0.0~),
          libkf6guiaddons-dev (>= 6.0.0~),

## kdevelop 25.07.90

=== debian/changelog ===
kdevelop (4:25.07.90-0ubuntu1) questing; urgency=medium

  * New upstream (RC) release (25.07.90)

 -- Rik Mills <rikmills@kde.org>  Fri, 25 Jul 2025 17:44:34 +0100

=== debian/control ===
--- 
+++ 
@@ -42,7 +42,7 @@
                libkf6threadweaver-dev (>= 6.0.0~),
                libkf6windowsystem-dev (>= 6.0.0~),
                libkf6xmlgui-dev (>= 6.0.0~),
-               libkomparediff2-dev (>= 4:25.07.80~),
+               libkomparediff2-dev (>= 4:25.07.90~),
                libksysguard-dev,
                libplasma-dev,
                libsvn-dev,

## kdevelop 25.08.0

=== plugins/qmljs/CMakeLists.txt ===
add_subdirectory(3rdparty/qtcreator-libs)

remove_definitions(
    -DQT_NO_FOREACH
)
add_subdirectory(duchain)
add_subdirectory(nodejsmodules)
if(BUILD_TESTING)
    add_subdirectory(tests)
endif()
add_subdirectory(codecompletion)

declare_qt_logging_category(kdevqmljslanguagesupport_LOG_SRCS
    TYPE PLUGIN
    IDENTIFIER KDEV_QMLJS
    CATEGORY_BASENAME "qmljs"
)
kdevplatform_add_plugin(kdevqmljs SOURCES
    qmljsparsejob.cpp
    qmljshighlighting.cpp
    kdevqmljsplugin.cpp
    navigation/propertypreviewwidget.cpp
    ${kdevqmljslanguagesupport_LOG_SRCS}
)
target_link_libraries(kdevqmljs
    kdevqmljsduchain
    kdevqmljscompletion
    Qt5::Widgets
    Qt5::QuickWidgets
    KF5::Declarative
    KDev::DefinesAndIncludesManager
)

install(DIRECTORY navigation/propertywidgets DESTINATION ${KDE_INSTALL_DATADIR}/kdevqmljssupport)

=== debian/changelog ===
kdevelop (4:25.08.0-0ubuntu1) questing; urgency=medium

  * New upstream release (25.08.0)

 -- Rik Mills <rikmills@kde.org>  Thu, 14 Aug 2025 11:52:00 +0100

=== debian/control ===
--- 
+++ 
@@ -42,7 +42,7 @@
                libkf6threadweaver-dev (>= 6.0.0~),
                libkf6windowsystem-dev (>= 6.0.0~),
                libkf6xmlgui-dev (>= 6.0.0~),
-               libkomparediff2-dev (>= 4:25.07.90~),
+               libkomparediff2-dev (>= 4:25.08.0~),
                libksysguard-dev,
                libplasma-dev,
                libsvn-dev,
